#!/usr/bin/env perl
#!/bin/env perl

## Name: sortbedid.pl
## Version: 1.2.5
## Date: May 03, 2016
## Author: Van Du Tran and Daniel Gautheret
## Maintainer: Van Du Tran and Daniel Gautheret

## sort in order that mate1 precedes mate2
# --input, input bed12 file with two mates following each other
# --ouput, output sorted file

use strict;
use warnings;
use Getopt::Long;

my $help;
my $input;
my $output;
my $line1;
my $line2;
my @args1;

usage() if (@ARGV < 2 or
	    ! GetOptions("help|?" => \$help,
			 "input=s" => \$input,
			 "output=s" => \$output)
	    or defined $help);

if (defined $input) {
    open(STDIN, $input);
}
if (defined $output) {
    open(STDOUT, ">$output");
}

while ($line1 = <STDIN>) {
    $line2 = <STDIN>;
    chomp($line1);
    @args1 = split("\t", $line1);
    if (index($args1[3], "/1")!=-1) {
	print STDOUT "$line1\n";
	print STDOUT "$line2";
    }
    else {
	print STDOUT "$line2";
	print STDOUT "$line1\n";
    }
}
close(STDIN);
close(STDOUT);
exit 0;

sub usage {
    print "Unknown option: @_\n" if ( @_ );
    print "Usage: perl sortbedid.pl --input BED [--output OUT] [--help|?] \n";
    exit 1;
}
